Document Relational Defintion Language
======

The Document Relational Defintion Language (DRDL, pronounced "dreidel") is the definition of a relational view of a MongoDB schema.  The file format is the default output of the `mongooschemagen` tool and is used by the `mongoddl` (TODO: pick a real name) tool to create/update the schema as seen BI tools.  Based on the [YAML](http://www.yaml.org/spec/1.2/spec.html) format, the file lists the databases, tables, and columns to be "exported" for use in various BI tools.

File Format
---
The file has the following basic format:

	schema:
	- db: <datbase name>
	  tables:
	  - table: <table name>
	    collection: <mongo collection name>
	    pipeline:
	    - <optional pipeline elements>
	    columns:
	    - name: <column name>
	      mongotype: <mongo field type>
	      sqltype: <mapped SQL type>

* `schema` : the top level element of the file and contains multiple `db` elements.
	* `db` : the database being modeled
		* `tables` : list of tables to exposed to the BI tool
			* `table` : the table name as seen by the BI tool.  This element's subelements are repeated once for each collection to be 
			exported.
				* `collection` : The collection backing this table
				* `pipeline` : a list of optional stages to be included in the aggregation pipeline used to fetch data for this table
				* `columns` : the list of columns for this table.  This element's subelements are repeated once for each field to 
				be included in the table.
					* `name` : the column name
					* `mongotype` : the type of the field in the mongodb collection.  Listed largely for reference/comparsion to the `sqltype`
					* `sqltype` : the type of the column in the table created
					
Example
-----

Given a documents of the following shape in the collection `arrays` in the database `schema_test`:

    {
        "_id": ObjectId("....")
        "close": 7.45,
        "detail": [2, 3, 4]
    }
    
The generated schema file will look like this:

	schema:
	- db: schema_test
	  tables:
	  - table: arrays
	    collection: schema_test.arrays
	    pipeline:
	    - $unwind: detail
	    columns:
	    - name: _id
	      mongotype: bson.ObjectId
	      sqltype: varchar
	    - name: close
	      mongotype: float64
	      sqltype: numeric
	    - name: detail
	      mongotype: int
	      sqltype: numeric